; ////////////////////////////
; /  I/O TRANIG UNIT MANUAL  /
; /	 PROGRAM 1 - 8	     /
; /	    91/01/21	     /
; ////////////////////////////

	ORG 8000H
; ***********************
; *	 PROGRAM 1	*
; ***********************

PRG1:	IN	A,(0E1H)
	OUT	(0E0H),A
	JP	PRG1

; ***********************
; *	 PROGRAM 2	*
; ***********************

PRG2:	LD	A,90H
	OUT	(0F3H),A
PR20:	LD	A,0FEH
	OUT	(0F1H),A
	LD	A,1
	OUT	(0F2H),A
	JP	PR20

; ***********************
; *	 PROGRAM 3	*
; ***********************

TIMER1m	EQU	0B94H

PRG3:	LD	SP,9F80H
	LD	A,90H
	OUT	(0F3H),A
PR30:	LD	A,0FEH
	OUT	(0F1H),A
	LD	A,8
	OUT	(0F2H),A
	CALL	TIMER1m
	LD	A,0FDH
	OUT	(0F1H),A
	LD	A,40H
	OUT	(0F2H),A
	CALL	TIMER1m
	LD	A,0FBH
	OUT	(0F1H),A
	LD	A,1
	OUT	(0F2H),A
	CALL	TIMER1m
	JP	PR30

; ***********************
; *	 PROGRAM 4	*
; ***********************

PRG4:	LD	SP,9F80H
	LD	A,90H
	OUT	(0F3H),A
PR40:	LD	A,0FEH
	OUT	(0F1H),A
	LD	A,8
	OUT	(0F2H),A
	CALL	TIMER1m
	LD	A,0
	OUT	(0F2H),A
	CALL	TIMER1u
	LD	A,0FDH
	OUT	(0F1H),A
	LD	A,40H
	OUT	(0F2H),A
	CALL	TIMER1m
	LD	A,0
	OUT	(0F2H),A
	CALL	TIMER1u
	LD	A,0FBH
	OUT	(0F1H),A
	LD	A,1
	OUT	(0F2H),A
	CALL	TIMER1m
	LD	A,0
	OUT	(0F2H),A
	CALL	TIMER1u
	JP	PR40

TIMER1u:
	PUSH	BC
	LD	BC,14H
	CALL	TIMER
	POP	BC
	RET

; ***********************
; *	 PROGRAM 5	*
; ***********************

PRG5:	LD	A,90H
	OUT	(0F3H),A
	LD	A,0F7H
	OUT	(0F1H),A
PR50:	IN	A,(0F0H)
	LD	(0FFFFH),A
	JP	PR50

; ***********************
; *	 PROGRAM 6	*
; ***********************

HEXBIN	EQU	92EH

PRG6:	LD	SP,9F80H
	LD	A,90H
	OUT	(0F3H),A
PR60:	LD	HL,DATA
	LD	BC,03FEH
PR61:	LD	A,0F7H
	AND	C
	OUT	(0F1H),A
	LD	A,(HL)
	OUT	(0F2H),A
	CALL	TIMER1m
	IN	A,(0F0H)
	PUSH	BC
	PUSH	HL
	CALL	HEXBIN
	POP	HL
	POP	BC
	LD	A,0
	OUT	(0F2H),A
	CALL	TIMER1u
	RLC	C
	INC	HL
	DJNZ	PR61
	JP	PR60

DATA	DB	8,40H,1

; ***********************
; *	50msec TIMER	*
; ***********************

TINER50:
	PUSH	BC
	LD	BC,3FCH
	CALL	TIMER
	POP	BC
	RET

TIMER:	PUSH	AF
LOOP:	DEC	BC
	LD	A,B
	OR	C
	JP	NZ,LOOP
	POP	AF
	RET


; ***********************
; *	 PROGRAM 7	*
; ***********************

INISIO	EQU	1A4H
TIMER1	EQU	56DH
TIMER20	EQU	32FH
HEXASC	EQU	5EEH

PRG7:	LD	SP,9F80H
	CALL	INISIO
	LD	A,90H
	OUT	(0F3H),A
PR70:	LD	A,1
	OUT	(0E0H),A
	IN	A,(0E1H)
	LD	B,A
	CALL	TIMER20
	LD	A,0
	OUT	(0E0H),A
	LD	A,B
	CALL	HEXASC
	LD	B,A
PR71:	IN	A,(0F5H)
	BIT	0,A
	JP	Z,PR71
	LD	A,B
	OUT	(0F4H),A
	CALL	TIMER1
	JP	PR70

; ***********************
; *	 PROGRAM 8	*
; ***********************
;  INTERRUPT CONTROL

EXLAMP	EQU	951H

PRG8:	LD	SP,9F80H
	IM	1
	CALL	INISIO
	LD	A,0
	LD	(9000H),A
PR80:	EI
PR81:	LD	A,(9000H)
	AND	A
	JP	NZ,PR82
	JP	PR81

PR82:	LD	A,0
	LD	(9000H),A
	LD	A,B
	CALL	HEXBIN
	JP	PR80

	ORG	9C00H
INT:	PUSH	AF
	IN	A,(0F4H)
	LD	B,A
	LD	A,1
	LD	(9000H),A
	CALL	EXLAMP
	POP	AF
	RETI

	END
